
#include "aubio_priv.h"
#include "sample.h"
#include "mathutils.h"
#include "pitchautocorr.h"

void aubio_pitch_autocorr(fvec_t * input, fvec_t * window, fvec_t * autocorr){
    uint_t i = 0, l = 0, k = 0, lmax = 0;
    smpl_t tmp = 0;
    for (i = 0; i < input->channels; i++) {
        /*
        for (k = 0; k < input->length; k++) {
            tmp = input->data[i][k]*input->data[i][k+l];
            autocorr->data[i][0] += tmp;
        }
        */
        for (l=0; l < input->length; l++) {
            lmax = input->length - l;
            for (k = 0; k < lmax; k++) {
                tmp = ABS(input->data[i][k]-input->data[i][k+l]); 
                    //* window->data[i][k];
                autocorr->data[i][l] += tmp;
            }
        }
    }
}

uint_t aubio_pitch_getautocorr(fvec_t * s) {
    uint_t i,j;
    uint_t L = 0;
    smpl_t tmp = 0.;
    for (i=0; i < s->channels; i++) {
        for (j=30; j < 100; j++) {
            L = (tmp > s->data[i][j])? L : j;
            tmp = (tmp > s->data[i][j])? tmp : s->data[i][j];
        }
        if (s->data[i][L/2] > s->data[i][L]/2. ){
            L = L/2;
            if (s->data[i][L/2] > s->data[i][L]/2. ) {
                L = L/2;
            } else if (s->data[i][L/3] > s->data[i][L]/2. ) {
                L = L/3;
            }
        } else {
            if (s->data[i][L/3] > s->data[i][L]/2. ) {
                L = L/3;
            } else if (s->data[i][L/5] > s->data[i][L]/2. ) {
                L = L/5;
            }
        }
    }
    return L;
}
